/*****************************************************************************/
/*                                                                           */
/*				     cpu.h				     */
/*                                                                           */
/*			     CPU type definitions			     */
/*                                                                           */
/*                                                                           */
/*                                                                           */
/* (C) 2000     Ullrich von Bassewitz                                        */
/*              Wacholderweg 14                                              */
/*              D-70597 Stuttgart                                            */
/* EMail:       uz@musoftware.de                                             */
/*                                                                           */
/*                                                                           */
/* This software is provided 'as-is', without any expressed or implied       */
/* warranty.  In no event will the authors be held liable for any damages    */
/* arising from the use of this software.                                    */
/*                                                                           */
/* Permission is granted to anyone to use this software for any purpose,     */
/* including commercial applications, and to alter it and redistribute it    */
/* freely, subject to the following restrictions:                            */
/*                                                                           */
/* 1. The origin of this software must not be misrepresented; you must not   */
/*    claim that you wrote the original software. If you use this software   */
/*    in a product, an acknowledgment in the product documentation would be  */
/*    appreciated but is not required.                                       */
/* 2. Altered source versions must be plainly marked as such, and must not   */
/*    be misrepresented as being the original software.                      */
/* 3. This notice may not be removed or altered from any source              */
/*    distribution.                                                          */
/*                                                                           */
/*****************************************************************************/



#ifndef CPU_H
#define CPU_H



/*****************************************************************************/
/*	     	    		     Data				     */
/*****************************************************************************/



/* Supported CPUs */
typedef enum CPUType {
    CPU_6502	= 0x01,
    CPU_65C02	= 0x02,
    CPU_65816  	= 0x04,
    CPU_ALL	= 0x07
} CPUType;

/* Current CPU */
extern CPUType	CPU;



/*****************************************************************************/
/*				     Code				     */
/*****************************************************************************/



void SetCPU (CPUType NewCPU);
/* Set a new CPU */



/* End of cpu.h */

#endif



